// include the library code:
#include <LiquidCrystal.h>

// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(5, 4, 3, 2, 1, 0);

int hallSensor_pin = 7;
int magnetValue;

void setup() {
  pinMode(PA1, OUTPUT);
  pinMode(PA3, OUTPUT);
  // set up the LCD's number of columns and rows:
  lcd.begin(16, 2);

  lcd.setCursor(1, 0);
  lcd.print("Reading Magnet");
  lcd.setCursor(0, 1);
  lcd.print("N");
  lcd.setCursor(15, 1);
  lcd.print("S");
}

void loop() {
  magnetValue = analogRead(hallSensor_pin);
  
  if ((magnetValue < 515) && (magnetValue >= 500)){
    lcd.setCursor(6, 1);
    lcd.print(" ||      ");
  }
  reading_N(magnetValue);
  reading_S(magnetValue);
}

void reading_N(int magValue){
  if ((magValue < 500) && (magValue >= 424)){
    lcd.setCursor(1, 1);
    lcd.print("     |");
  }
  if ((magValue < 423) && (magValue >= 339)){
    lcd.setCursor(1, 1);
    lcd.print("    |");
  }
  if ((magValue < 339) && (magValue >= 255)){
    lcd.setCursor(1, 1);
    lcd.print("   |");
  }
  if ((magValue < 255) && (magValue >= 171)){
    lcd.setCursor(1, 1);
    lcd.print("  |");
  }
  if ((magValue < 171) && (magValue >= 87)){
    lcd.setCursor(1, 1);
    lcd.print(" |");
  }
  if ((magValue < 87) && (magValue >= 0)){
    lcd.setCursor(1, 1);
    lcd.print("|");
  }
}

void reading_S(int magValue){
  if ((magValue > 516) && (magValue <= 585)){
    lcd.setCursor(9, 1);
    lcd.print("|     ");
  }
  else if ((magValue > 586) && (magValue <= 658)){
    lcd.setCursor(10, 1);
    lcd.print("|    ");
  }
  else if ((magValue > 659) && (magValue <= 731)){
    lcd.setCursor(11, 1);
    lcd.print("|   ");
  }
  else if ((magValue > 732) && (magValue <= 804)){
    lcd.setCursor(12, 1);
    lcd.print("|  ");
  }
  else if ((magValue > 805) && (magValue <= 950)){
    lcd.setCursor(13, 1);
    lcd.print("| ");
  }
  else if ((magValue > 951) && (magValue <= 1024)){
    lcd.setCursor(14, 1);
    lcd.print("|");
  }
}

